using System;
using System.Linq;
using UnityEngine;

namespace CheesyFX
{
    public class ProximityHandler : MonoBehaviour
    {
        public Orifice orifice;
        public bool on;
        public FreeControllerV3 currentTipCtrl;
        private int numCollisions;
        private Penetrator candidate;
	    
        private void OnTriggerEnter(Collider other)
        {
            if (other.isTrigger || !FillMeUp.singleton.enabled) return;
            if(numCollisions == 0) orifice.onProximityEnter.Trigger();
            numCollisions++;
            if(orifice.autoTogglePenisTip.val)
            {
                if (on || other.name != "AutoColliderGen3bHard") return;
                currentTipCtrl = other.GetAtom().freeControllers.FirstOrDefault(x => x.name == "penisTipControl");
                if (!currentTipCtrl) return;
                currentTipCtrl.currentPositionState = FreeControllerV3.PositionState.On;
                currentTipCtrl.currentRotationState = FreeControllerV3.RotationState.On;
                // currentTip.transform.position = new Vector3(0f, orifice.enterPointTF.InverseTransformVector(currentTip.transform.position -orifice.enterPointTF.position).y, 0f);
                on = true;
            }
		    
            if (orifice.isPenetrated || !orifice.magnetic.val || (!(orifice is Throat) && orifice.other.isPenetrated)) return;
            if (FillMeUp.penetratorByCollider.TryGetValue(other, out candidate))
            {
                orifice.magnet.penetrator = candidate;
                orifice.magnet.enabled = true;
                // $"{orifice} {candidate.atom} {candidate.tipCollider}".Print();
            }
        }

        private void OnTriggerExit(Collider other)
        {
            if (other.isTrigger || !FillMeUp.singleton.enabled) return;
            numCollisions--;
            if (numCollisions == 0)
            {
                Reset();
                // orifice.depthForce.enabled = false;
            }
        }

        public void Reset()
        {
            numCollisions = 0;
            orifice.onProximityExit.Trigger();
            orifice.magnet.enabled = false;
            orifice.magnet.penetrator = null;
            // orifice.thrustForce.enabled = orifice.maleForce.enabled = false;
        }

        private void OnDisable()
        {
            Reset();
        }
    }
}