using System;
using System.Collections;
using System.Linq;
using MacGruber;
using MeshVR;
using MVR.FileManagementSecure;
using SimpleJSON;
using UnityEngine;
using UnityEngine.UI;
using Object = UnityEngine.Object;

namespace CheesyFX
{
    public class Pose
    {
        public UIDynamicButton uiButton;
        public JSONClass pose;
        public byte[] img;
        private int _id;
        public static IEnumerator smoothCam;
        public static bool smoothCamRunning;
        public EventTrigger onPoseEnter;
        public EventTrigger onPoseExit;
        private static Color selectedBGColor = new Color(0.48f, 0.48f, 0.48f);
        private static Color deselectedBGColor = new Color(0.76f, 0.76f, 0.76f, 0f);
        private static Color selectedColor = Color.white;
        public static Color deselectedColor = new Color(1f, 1f, 1f, PoseMe.buttonTransparency.val);
        private bool _selected;

        public PoseForce poseForce;
        public string actors => "<b>Stored actors:</b> "+string.Join(", ", pose["pose"].AsObject.Keys.ToArray());
        public bool selected
        {
            get { return _selected;}
            set
            {
                _selected = value;
                if (value)
                {
                    uiButton.button.image.color = selectedColor;
                    backdropImage.color = selectedBGColor;
                    if(PoseMe.applyForces.val && poseForce) poseForce.enabled = true;
                }
                else
                {
                    uiButton.button.image.color = deselectedColor;
                    backdropImage.color = deselectedBGColor;
                    if(poseForce) poseForce.enabled = false;
                }
            }
        }

        private static Atom containingAtom => PoseMe.atom;
        public int id
        {
            get { return _id; }
            set
            {
                if (value == _id) return;
                _id = value;
                if(uiButton != null) uiButton.label = _id.ToString();
            }
        }

        public Pose(int id)
        {
            if(PoseMe.currentPose != null)
            {
                PoseMe.currentPose.selected = false;
            }
            _id = id;
            onPoseEnter = new EventTrigger(PoseMe.singleton, "On Pose Enter");
            onPoseExit = new EventTrigger(PoseMe.singleton, "On Pose Exit");
            pose = GetPose();
            PoseMe.currentPose = this;
            PoseMe.onPoseEnterTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseExitTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseEnterTriggerButton.button.onClick.AddListener(onPoseEnter.OpenPanel);
            PoseMe.onPoseExitTriggerButton.button.onClick.AddListener(onPoseExit.OpenPanel);
            AddButton();
            backdropImage.color = selectedBGColor;
            PoseMe.actorsJ.val = actors;
            poseForce = PoseMe.singleton.gameObject.AddComponent<PoseForce>().Init();
            selected = true;
        }
        
        public Pose(int id, JSONClass pose)
        {
            this.pose = pose;
            _id = id;
            onPoseEnter = new EventTrigger(PoseMe.singleton, "On Pose Enter");
            onPoseExit = new EventTrigger(PoseMe.singleton, "On Pose Exit");
            PoseMe.currentPose = this;
            PoseMe.onPoseEnterTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseExitTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseEnterTriggerButton.button.onClick.AddListener(onPoseEnter.OpenPanel);
            PoseMe.onPoseExitTriggerButton.button.onClick.AddListener(onPoseExit.OpenPanel);
            foreach (JSONClass jc in pose["pose"][containingAtom.name]["storables"].AsArray)
            {
                if (jc["id"].Value != "control") continue;
                storedWorldToLocalMatrix = Matrix4x4.TRS(jc["position"].AsObject.ToV3(), Quaternion.Euler(jc["rotation"].AsObject.ToV3()), Vector3.one).inverse;
                break;
            }
            onPoseEnter.RestoreFromJSON(pose, PoseMe.singleton.subScenePrefix, false, true);
            onPoseExit.RestoreFromJSON(pose, PoseMe.singleton.subScenePrefix, false, true);
            if(pose.HasKey("img")) img = Convert.FromBase64String(pose["img"]);
            AddButton();
            SetButtonImage();
            
            poseForce = PoseMe.singleton.gameObject.AddComponent<PoseForce>().Init();
        }

        public void Update()
        {
            pose = GetPose();
            PoseMe.actorsJ.val = actors;
        }

        public void UpdateTriggers()
        {
            pose[onPoseEnter.Name] = onPoseEnter.GetJSON(PoseMe.singleton.subScenePrefix);
            pose[onPoseExit.Name] = onPoseExit.GetJSON(PoseMe.singleton.subScenePrefix);
        }
        
        private JSONClass GetPose()
        {
            storedWorldToLocalMatrix = containingAtom.mainController.transform.worldToLocalMatrix;
            // Matrix4x4.TRS(containingAtom.mainController.transform.position, containingAtom.mainController.transform.rotation, Vector3.one).inverse.Print();
            PoseMe.dildos.Clear();
            var jc = new JSONClass();
            jc["SceneType"] = PoseMe.sceneType;
            // jc["path"] = path.val;
            jc["id"] = id.ToString();
            var jcPose = jc["pose"] = new JSONClass();
            jcPose[containingAtom.uid] = GetPersonPose(containingAtom);
            foreach (var atom in SuperController.singleton.GetAtoms())
            {
                if (atom != containingAtom && atom.type == "Person")
                {
                    jcPose[atom.uid] = GetPersonPose(atom);
                }
                else if (atom.type == "Dildo")
                {
                    jcPose[atom.uid] = GetDildoPose(atom);
                }
            }
            if(PoseMe.manageForces.val)
            {
                var jcForces = new JSONClass();
                var hasForces = false;
                foreach (var fuckable in FillMeUp.fuckables)
                {
                    if (!fuckable.isPenetrated) continue;
                    var jcFuckable = jcForces[fuckable.name] = new JSONClass();
                    fuckable.StoreForces(jcFuckable.AsObject);
                    hasForces = true;
                }

                if (hasForces) jc["Forces"] = jcForces;
            }
            jc[onPoseEnter.Name] = onPoseEnter.GetJSON(PoseMe.singleton.subScenePrefix);
            jc[onPoseExit.Name] = onPoseExit.GetJSON(PoseMe.singleton.subScenePrefix);
            TakeScreenshot(jc);
            return jc;
        }
        
        private JSONClass GetPersonPose(Atom atom)
        {
            JSONClass poseJSON = null;
            var storables = atom.GetStorableIDs().Select(atom.GetStorableByID)
                .Where(t => !t.exclude && t.gameObject.activeInHierarchy)
                .Where(ShouldStorableBeIncluded);
            var storablesJSON = new JSONArray();
            
            foreach (var storable in storables)
            {
                var jc = storable.GetJSON(true, false, storable.name != "geometry");
                if (atom != containingAtom && jc["id"].Value == "control")
                {
                    jc["position"] = storedWorldToLocalMatrix.MultiplyPoint(atom.mainController.transform.position).ToJC();
                    jc["rotation"] = (storedWorldToLocalMatrix.rotation * atom.mainController.transform.rotation).eulerAngles.ToJC();
                }
                storablesJSON.Add(jc);
            }

            var genderListener = FillMeUp.persons.First(x => x.atom == atom).genderListener;
            poseJSON = new JSONClass
            {
                ["setUnlistedParamsToDefault"] = { AsBool = true },
                ["V2"] = { AsBool = true },
                ["gender"] = genderListener.dcs.gender.ToString(),
                ["futa"] = {AsBool = genderListener.isFuta},
                ["handPose"] = GetHandPose(atom),
                ["storables"] = storablesJSON
            };
            return poseJSON;
        }
        
        private static bool ShouldStorableBeIncluded(JSONStorable t)
        {
            if (t is FreeControllerV3) return true;
            if (t is DAZBone) return true;
            if (t.storeId == "geometry" && t is DAZCharacterSelector) return false;
            return false;
        }

        private JSONArray GetHandPose(Atom atom)
        {
            var ja = new JSONArray();
            var dcs = atom.GetStorableByID("geometry") as DAZCharacterSelector;
            foreach (var morph in dcs.morphsControlUI.GetMorphs())
            {
                if (!morph.isPoseControl || !morph.hasFormulas || !HasFingerFormula(morph)) continue;
                var jc = new JSONClass();
                if (morph.StoreJSON(jc, true))
                {
                    ja.Add(jc);
                }
            }
            return ja;
        }

        private bool HasFingerFormula(DAZMorph morph)
        {
            var hasFingerTargets = morph.formulas.Any(x =>
            {
                var tgt = x.target;
                return tgt.Contains("Thumb") || 
                       tgt.Contains("Index") || 
                       tgt.Contains("Mid") || 
                       tgt.Contains("Ring") ||
                       tgt.Contains("Pinky");
            });
            return hasFingerTargets;
        }

        private JSONClass GetDildoPose(Atom atom)
        {
            JSONClass jc = new JSONClass();
            jc["control"] = new JSONClass
            {
                ["pos"] = storedWorldToLocalMatrix.MultiplyPoint(atom.mainController.transform.position).ToJA(),
                ["rot"] = (storedWorldToLocalMatrix.rotation * atom.mainController.transform.rotation).eulerAngles.ToJA()
            };
            foreach (var rb in atom.GetComponentsInChildren<Rigidbody>())
            {
                jc[rb.name] = new JSONClass
                {
                    ["pos"] = storedWorldToLocalMatrix.MultiplyPoint(rb.position).ToJA(),
                    ["rot"] = (storedWorldToLocalMatrix.rotation * rb.rotation).eulerAngles.ToJA()
                };
            }
            return jc;
        }
        
        private Matrix4x4 storedWorldToLocalMatrix;
        private Matrix4x4 currentLocalToWorldMatrix;
        
        public void Apply()
        {
            PoseMe.actorsJ.val = actors;
            if (PoseMe.currentPose != null && PoseMe.currentPose != this)
            {
                PoseMe.currentPose.onPoseExit.Trigger();
                PoseMe.currentPose.selected = false;
            }
            onPoseEnter.Trigger();
            PoseMe.currentPose = this;
            PoseMe.onPoseEnterTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseExitTriggerButton.button.onClick.RemoveAllListeners();
            PoseMe.onPoseEnterTriggerButton.button.onClick.AddListener(onPoseEnter.OpenPanel);
            PoseMe.onPoseExitTriggerButton.button.onClick.AddListener(onPoseExit.OpenPanel);
            PoseMe.poseChooser.valNoCallback = PoseMe.poses.IndexOf(this).ToString();
            PoseMe.applyPosePost.Stop();
            PoseMe.softPhysicsStates.Clear();
            for (int i = 0; i < FillMeUp.persons.Count; i++)
            {
                PoseMe.softPhysicsStates.Add(PoseMe.persons[i].GetSoftPhysicsState());
            }
            currentLocalToWorldMatrix = containingAtom.mainController.transform.localToWorldMatrix;
            
            ApplyPersonPose(containingAtom);
            foreach (string atomUid in pose["pose"].AsObject.Keys)
            {
                if(atomUid == PoseMe.atom.uid) continue;
                var atom = SuperController.singleton.GetAtomByUid(atomUid);
                if (atom == null)
                {
                    $"Atom {atomUid} not found".Print();
                    continue;
                }
                if(atom.type == "Person")
                {
                    ApplyPersonPose(atom);
                }
            }
            smoothCam.Stop();
            smoothCamRunning = false;
            if (pose.HasKey("camera"))
            {
                var cameraJc = pose["camera"];
                switch (PoseMe.camMode.val)
                {
                    case "None":
                    {
                        break;
                    }
                    case "Exponential":
                    {
                        smoothCam = SmoothCamRestoreExp(cameraJc["rigPosition"].AsArray.ToV3(),
                            Quaternion.Euler(cameraJc["rigRotation"].AsArray.ToV3()),
                            Quaternion.Euler(cameraJc["cameraRotation"].AsArray.ToV3()),
                            cameraJc["playerHeight"].AsFloat,
                            cameraJc["focusDistance"].AsFloat).Start();
                        break;
                    }
                    case "Linear":
                    {
                        smoothCam = SmoothCamRestoreLin(cameraJc["rigPosition"].AsArray.ToV3(),
                            Quaternion.Euler(cameraJc["rigRotation"].AsArray.ToV3()),
                            Quaternion.Euler(cameraJc["cameraRotation"].AsArray.ToV3()),
                            cameraJc["playerHeight"].AsFloat,
                            cameraJc["focusDistance"].AsFloat).Start();
                        break;
                    }
                    default:
                    {
                        var camRigPos = cameraJc["rigPosition"].AsArray.ToV3();
                        var focusDistance = cameraJc["focusDistance"].AsFloat;
                        PoseMe.cameraRig.position = camRigPos;
                        PoseMe.cameraRig.rotation = Quaternion.Euler(cameraJc["rigRotation"].AsArray.ToV3());
                        PoseMe.camera.rotation = Quaternion.Euler(cameraJc["cameraRotation"].AsArray.ToV3());
                        SuperController.singleton.playerHeightAdjust = cameraJc["playerHeight"].AsFloat;
                        SuperController.singleton.focusDistance = focusDistance;
                        break;
                    }
                }
                
                

                

                // if (PoseMe.isVR && SuperController.singleton.mainHUD.gameObject.activeSelf)
                // {
                //     PoseMe.cameraRig.position += .1f * focusDistance * PoseMe.cameraRig.right;
                // }
                // PoseMe.cameraRig.position = camRigPos;

            }
            PoseMe.applyPosePost = ApplyPosePost(pose.AsObject).Start();
            SetPreviewImage();
            selected = true;
        }

        private IEnumerator SmoothCamRestoreLin(Vector3 rigPos, Quaternion rigRot, Quaternion camRot, float height, float focus)
        {
            smoothCamRunning = true;
            var rigPosCur = PoseMe.cameraRig.position;
            var rigRotCur = PoseMe.cameraRig.rotation;
            var camRotCur = PoseMe.camera.rotation;
            var heightCur = SuperController.singleton.playerHeightAdjust;
            var focusCur = SuperController.singleton.focusDistance;
            float t = 0f;
            while (t < 1f)
            {
                t += .5f*PoseMe.smoothCamSpeed.val*Time.fixedDeltaTime;
                if (t > 1f) t = 1f;
                PoseMe.cameraRig.position = Vector3.Lerp(rigPosCur, rigPos, t);
                PoseMe.cameraRig.rotation = Quaternion.Lerp(rigRotCur, rigRot, t);
                PoseMe.camera.rotation = Quaternion.Lerp(camRotCur, camRot, t);
                SuperController.singleton.playerHeightAdjust = Mathf.Lerp(heightCur, height, t);
                SuperController.singleton.focusDistance = Mathf.Lerp(focusCur, focus, t);
                yield return new WaitForFixedUpdate();
            }
            smoothCamRunning = false;
        }
        
        private IEnumerator SmoothCamRestoreExp(Vector3 rigPos, Quaternion rigRot, Quaternion camRot, float height, float focus)
        {
            smoothCamRunning = true;
            var deltaT = PoseMe.smoothCamSpeed.val * Time.fixedDeltaTime;
            while (Mathf.Abs(Quaternion.Dot(PoseMe.camera.rotation,camRot)) < 0.999999999999f || 
                   Mathf.Abs(Quaternion.Dot(PoseMe.cameraRig.rotation,rigRot)) < 0.999999999999f)
            {
                PoseMe.cameraRig.position = Vector3.Lerp(PoseMe.cameraRig.position, rigPos, 1.5f*deltaT);
                PoseMe.cameraRig.rotation = Quaternion.Lerp(PoseMe.cameraRig.rotation, rigRot, deltaT);
                PoseMe.camera.rotation = Quaternion.Lerp(PoseMe.camera.rotation, camRot, deltaT);
                SuperController.singleton.playerHeightAdjust = Mathf.Lerp(SuperController.singleton.playerHeightAdjust, height, deltaT);
                SuperController.singleton.focusDistance = Mathf.Lerp(SuperController.singleton.focusDistance, focus, deltaT);
                yield return new WaitForFixedUpdate();
            }
            smoothCamRunning = false;
            // PoseMe.cameraRig.position = rigPos;
            // PoseMe.cameraRig.rotation = rigRot;
            // PoseMe.camera.rotation = camRot;
            // SuperController.singleton.playerHeightAdjust = height;
            // SuperController.singleton.focusDistance = focus;
        }

        private void ApplyPersonPose(Atom atom)
        {
            try
            {
                Quaternion headCtrlRot = Quaternion.identity;
                Quaternion headRot = Quaternion.identity;
                Quaternion neckRot = Quaternion.identity;
                Quaternion chestRot = Quaternion.identity;
                FreeControllerV3 headCtrl = null;
                DAZBone head = null;
                DAZBone neck = null;
                DAZBone chest = null;
            
                if (!PoseMe.restoreHeadRotation.val)
                {
                    headCtrl = atom.freeControllers.First(x => x.name == "headControl");
                    var bones = atom.GetComponentsInChildren<DAZBone>();
                    for (int i = 0; i < bones.Length; i++)
                    {
                        var bone = bones[i];
                        if (bone.name == "head") head = bone;
                        else if (bone.name == "neck") neck = bone;
                        else if (bone.name == "chest") chest = bone;
                    }
                    headCtrlRot = headCtrl.transform.localRotation;
                    headRot = head.transform.localRotation;
                    neckRot = neck.transform.localRotation;
                    chestRot = chest.transform.localRotation;
                }
            
                PresetManagerControl pmc = atom.presetManagerControls.First(x => x.name == "PosePresets");
                var pm = pmc.GetComponent<PresetManager>();
                
                var personJc = pose["pose"][atom.uid].AsObject;
                if(atom == containingAtom)
                {
                    
                    if (!PoseMe.restoreRoot.val)
                    {
                        
                        var controlJc = personJc["storables"].Childs.First(x => x["id"].Value == "control");
                        controlJc["id"] = "_control";
                        pm.LoadPresetFromJSON(personJc);
                        controlJc["id"] = "control";
                    }
                    else pm.LoadPresetFromJSON(personJc);
                }
                else
                {
                    Matrix4x4 refMatrix;
                    if(!PoseMe.restoreRoot.val)
                    {
                        refMatrix = currentLocalToWorldMatrix;
                    }
                    else
                    {
                        refMatrix = storedWorldToLocalMatrix.inverse;
                    }
                    var controlJc = personJc["storables"].Childs.First(x => x["id"].Value == "control");
                    var storedPos = controlJc["position"].AsObject.ToV3();
                    var storedRot = controlJc["rotation"].AsObject.ToV3();
                    
                    controlJc["position"] = refMatrix.MultiplyPoint(storedPos).ToJC();
                    controlJc["rotation"] = (refMatrix.rotation * Quaternion.Euler(storedRot)).eulerAngles.ToJC();
                    pm.LoadPresetFromJSON(personJc);
                    controlJc["position"] = storedPos.ToJC();
                    controlJc["rotation"] = storedRot.ToJC();
                }

                if (!PoseMe.restoreHeadRotation.val)
                {
                    headCtrl.transform.localRotation = headCtrlRot;
                    head.transform.localRotation = headRot;
                    neck.transform.localRotation = neckRot;
                    chest.transform.localRotation = chestRot;
                }

                if (personJc.HasKey("handPose"))
                {
                    var dcs = atom.GetStorableByID("geometry") as DAZCharacterSelector;
                    foreach (var morphJc in personJc["handPose"].Childs)
                    {
                        var morph = dcs.morphsControlUI.GetMorphByUid(morphJc["uid"]);
                        morph.morphValue = morphJc["value"].AsFloat;
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError(e.ToString());
            }
        }
        
        private void ApplyDildoPose(Atom atom, JSONClass pose)
        {
            Matrix4x4 refMatrix;
            if(!PoseMe.restoreRoot.val)
            {
                refMatrix = currentLocalToWorldMatrix;
            }
            else
            {
                refMatrix = storedWorldToLocalMatrix.inverse;
            }

            var controlJc = pose["control"];
            var pos = controlJc["pos"].AsArray.ToV3();
            var rot = controlJc["rot"].AsArray.ToV3();
            
            atom.mainController.transform.position = refMatrix.MultiplyPoint(pos);
            atom.mainController.transform.rotation = refMatrix.rotation * Quaternion.Euler(rot);
            
            foreach (var rb in atom.GetComponentsInChildren<Rigidbody>())
            {
                rb.position = refMatrix.MultiplyPoint(pose[rb.name]["pos"].AsArray.ToV3());
                rb.rotation = refMatrix.rotation * Quaternion.Euler(pose[rb.name]["rot"].AsArray.ToV3());
            }
        }
        
        private IEnumerator ApplyPosePost(JSONClass pose)
        {
            for (int i = 0; i < PoseMe.dildos.Count; i++)
            {
                PoseMe.dildos[i].collisionEnabled = false;
            }
            yield return new WaitUntil(() =>
            {
                for (int i = 0; i < PoseMe.persons.Count; i++)
                {
                    if (PoseMe.persons[i].GetSoftPhysicsState() != PoseMe.softPhysicsStates[i]) return false;
                }
                return true;
            });
            var poseJc = pose["pose"].AsObject;
            foreach (string atomUid in poseJc.Keys)
            {
                var atom = SuperController.singleton.GetAtomByUid(atomUid);
                if (atom == null) continue;
                var atomPose = poseJc[atomUid].AsObject;
                if (atom.type == "Person")
                {
                    // JSONArray storables = atomPose["storables"].AsArray;
                    // foreach (var bone in atom.GetComponentsInChildren<DAZBone>())
                    // {
                    //     
                    //     for (int i = 0; i < storables.Count; i++)
                    //     {
                    //         JSONClass jc = storables[i].AsObject;
                    //         if(jc["id"] != bone.name) continue;
                    //         bone.Print();
                    //         bone.RestoreFromJSON(jc);
                    //     }
                    // }
                }
                else if(atom.type == "Dildo")
                {
                    ApplyDildoPose(atom, poseJc[atom.uid].AsObject);
                }
            }
            for (int i = 0; i < PoseMe.dildos.Count; i++)
            {
                PoseMe.dildos[i].collisionEnabled = true;
            }

            if (PoseMe.manageForces.val && pose.HasKey("Forces"))
            {
                var jcForces = pose["Forces"].AsObject;
                foreach (var fuckable in FillMeUp.fuckables)
                {
                    if(!jcForces.HasKey(fuckable.name)) continue;
                    fuckable.LoadForces(jcForces[fuckable.name].AsObject);
                }
            }

            // if (PoseMe.restoreCamera.val && pose.HasKey("camera"))
            // {
            //     PoseMe.cameraRig.transform.position = pose["camera"]["position"].AsArray.ToV3();
            //     
            //     PoseMe.camera.rotation = Quaternion.Euler(pose["camera"]["rotation"].AsArray.ToV3());
            //     SuperController.singleton.FocusOnController(PoseMe.atom.mainController);
            //     // SuperController.singleton.playerHeightAdjust = pose["camera"]["position"].AsArray.ToV3()[1];
            //     SuperController.singleton.playerHeightAdjust = pose["camera"]["playerHeight"].AsFloat;
            //     
            // }
        }

        public RectTransform buttonRT;
        private Image backdropImage;
        
        private void AddButton()
        {
            buttonRT = Object.Instantiate(PoseMe.singleton.manager.configurableButtonPrefab) as RectTransform;
            Object.Destroy(buttonRT.GetComponentInChildren<UIDynamicButton>());
            Object.Destroy(buttonRT.GetComponentInChildren<Button>());
            Object.Destroy(buttonRT.GetComponentInChildren<Text>());
            backdropImage = buttonRT.GetComponent<Image>();
            backdropImage.color = deselectedBGColor;
            buttonRT.SetParent(PoseMe.canvas.transform, false);
            
            RectTransform button = Object.Instantiate(PoseMe.singleton.manager.configurableButtonPrefab) as RectTransform;
            // button.SetParent(PoseMe.canvas.transform, false);
            button.SetParent(buttonRT, false);
            button.anchorMax = new Vector2(.98f, .98f);
            button.anchorMin = new Vector2(.02f, .02f);
            button.offsetMax = new Vector2();
            button.offsetMin = new Vector2();

            uiButton = button.GetComponent<UIDynamicButton>();
            uiButton.label = _id.ToString();
            uiButton.buttonText.fontSize = 30;
            uiButton.buttonText.color = Color.black;
            uiButton.button.image.color = deselectedColor;
            uiButton.button.onClick.AddListener(Apply);
            var cb = uiButton.button.colors;
            cb.pressedColor = cb.highlightedColor = cb.normalColor;
            uiButton.button.colors = cb;
        }

        public void RemoveButton()
        {
            Object.Destroy(uiButton.transform.parent.gameObject);
        }

        public void StoreImage(string jsonPath)
        {
            if(img != null) FileManagerSecure.WriteAllBytes(jsonPath.Replace(".json", ".jpg"), img);
        }

        // public void DeleteFromDisk()
        // {
        //     if (!FileManagerSecure.FileExists(path.val + ".json")) return;
        //     FileManagerSecure.DeleteFile(path.val+".json");
        //     FileManagerSecure.DeleteFile(path.val+".jpg");
        // }

        public void StoreBackup()
        {
            var backupPath = $"{PoseMe.backUpStorePath}{PoseMe.sceneType}_{DateTime.Now:yyyy-MM-dd-HHMMss}";
            if(img != null) FileManagerSecure.WriteAllBytes(backupPath+".jpg", img);
            SuperController.singleton.SaveJSON(pose, backupPath+".json");
            // FileManagerSecure.MoveFile(path.val+".json", backupName + ".json");
            // FileManagerSecure.MoveFile(path.val + ".jpg", backupName + ".jpg");
            $"PoseMe: Backup stored at {backupPath}.".Print();
        }

        public void SyncAtomNames(string oldUid, string newUid)
        {
            onPoseExit.SyncAtomNames();
            onPoseExit.SyncAtomNames();
            var atomPoses = pose["pose"];
            atomPoses[newUid] = atomPoses[oldUid];
            atomPoses.Remove(oldUid);
        }

        private void TakeScreenshot(JSONClass jc)
        {
            SuperController.singleton.DoSaveScreenshot(PoseMe.tmpPath+"1.jpg", val => OnScreenshotTaken(val, jc));
        }

        private void OnScreenshotTaken(string imagePath, JSONClass jc)
        {
            if(!FileManagerSecure.FileExists(imagePath)) return;
            img = FileManagerSecure.ReadAllBytes(imagePath);
            FileManagerSecure.DeleteFile(imagePath);
            pose["img"] = Convert.ToBase64String(img);
            var rigPos = PoseMe.cameraRig.position;
            jc["camera"] = new JSONClass
            {
                ["rigPosition"] = rigPos.ToJA(),
                ["rigRotation"] = PoseMe.cameraRig.rotation.eulerAngles.ToJA(),
                ["cameraRotation"] = PoseMe.camera.rotation.eulerAngles.ToJA(),
                ["playerHeight"] = {AsFloat = SuperController.singleton.playerHeightAdjust},
                ["focusDistance"] = {AsFloat = SuperController.singleton.focusDistance} 
            };
            // SuperController.singleton.SaveJSON(pose, $"{path.val}_.json");
            SetButtonImage(PoseMe.showThumbnails.val);
            SetPreviewImage();
        }
        
        // public void FetchThumbnail(string path)
        // {
        //     img = FileManagerSecure.ReadAllBytes(path);
        //     FileManagerSecure.WriteAllBytes(this.path.val+".jpg", img);
        //     SetButtonImage(PoseMe.showThumbnails.val);
        // }
        
        public void SetButtonImage(bool showThumbnail = true)
        {
            if(showThumbnail && img != null)
            {
                var texture = LoadTexture(img);
                uiButton.button.image.sprite = Sprite.Create(texture,
                    new Rect(0.0f, 0.0f, texture.width, texture.height), new Vector2(0.5f, 0.5f));
                uiButton.buttonText.alignment = TextAnchor.UpperRight;
                uiButton.buttonText.color = Color.clear;
                uiButton.buttonText.fontSize = 30;
                
            }
            else
            {
                uiButton.button.image.sprite = null;
                uiButton.buttonText.alignment = TextAnchor.MiddleCenter;
                uiButton.buttonText.color = Color.black;
                uiButton.buttonText.fontSize = 40;
            }
        }

        private void SetPreviewImage()
        {
            if(img == null) return;
            var texture = LoadTexture(img);
            PoseMe.previewImage.sprite = Sprite.Create(texture,
                new Rect(0.0f, 0.0f, texture.width, texture.height), new Vector2(0.5f, 0.5f));
        }
        
        public static Texture2D LoadTexture(string path)
        {
            var tex = new Texture2D(2, 2);
            var data = FileManagerSecure.ReadAllBytes(path);
            tex.LoadImage(data);
            
            // var pixels = tex.GetPixels();
            // for (int i = 0; i < pixels.Length; i++)
            // {
            //     var pixel = pixels[i];
            //     
            //     if (pixel.ToHSV().V < .1f)
            //     {
            //         // pixel.ToHSV().V.Print();
            //         // pixel.a = 0f;
            //         // pixels[i] = pixel;
            //         var col = Color.white;
            //         col.a = 0f;
            //         pixels[i] = col;
            //     }
            //     // pixels[i] *= Color.Lerp(color, pixels[i], maskPixels[i].a);
            // }
            // tex.SetPixels(pixels);
            tex.Apply();
            return tex;
        }

        private static Texture2D LoadTexture(byte[] image)
        {
            var tex = new Texture2D(2, 2);
            tex.LoadImage(image);
            tex.Apply();
            return tex;
        }
    }
}